//------------------------------------------------------------
// $Id: PRC_PErecvStandAlone.cc,v 1.1.1.1 1999/11/25 06:26:09 yamauchi Exp $ 
//------------------------------------------------------------
//	PRC_PErecvStandAlone.cc 
//	Proximity Clouds method
// 
//	(C) Copyright 1998 Mayumi TOKUNAGA	 ͳ
//	(C) Copyright 1998 Hitoshi YAMAUCHI	 
//------------------------------------------------------------
#include "PE.h"

#ifndef FOR_STANDALONE
# error "This file is for stand alone mode."
#endif

void PEClass::
receivePRCSkipMap(int bytesize,  OBJINSPC_IMPLEMENT_TYPE * pDatArray)
{
    int size[3];
    size[0] = size[1] = size[2] = this->mSpcParam.getSubDivNum();
    const int totalSize = size[0] * size[1] * size[2];
    assert(totalSize > 0);	//  SpcParam ϼѤߤΤϤ
    assert(totalSize == bytesize);

    // Map ΰȽ
    this->mPRCUnit.mObjInSpcMap.initBySizeWithBaseZero(size); 
    
    // ƤΥԡ
    for(int i = 0; i < this->mPRCUnit.mObjInSpcMap.getTotalSize(); i++)
    {
	PRC_skipMapClass oeias(pDatArray[i]);
	this->mPRCUnit.mObjInSpcMap.setAsOneDimArray(i, oeias);
    }
}

