//------------------------------------------------------------
// $Id: frustumSRG.h,v 1.1.1.1 1999/11/25 06:26:09 yamauchi Exp $
//------------------------------------------------------------
// distribute secondary ray generation	
//	ȯ˿ΤѤʬ쥤ȯ롥
//
//	Original file is prbDist.h by TOKUNAGA Mayumi
//	Changed to frustumSRG.h by YAMAUCHI Hitoshi
//
//	Copyright (C) 1998  TOKUNAGA Mayumi   ͳ
//	Copyright (C) 1998  YAMAUCHI Hitoshi  
//
// Τ̤ꤹ롥
//
// ƥѥ᡼ꤹե
//	̤β 	: view file 
// 	        	: material data 
//---------------------------------------------------------
#ifndef _frustumSRG_h
#define _frustumSRG_h 1

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <math.h>
#include <assert.h>
#include "Vector3.h"

class frustumSRGClass {
private:
    // frustum Ϥƥԡʤᡤ copy constructor ط
    // ѤǤʤ롥 
    frustumSRGClass(const frustumSRGClass &rhs);
    const frustumSRGClass& operator=(const frustumSRGClass &rhs);    

protected:
    int     mBaseSquareEdgeResol;	// դβ
    int     mNumberOfTotalSamples;	// ץ󥰿 = ^2 = pixel 
    Vector3 *mpPixelBasePos;	// ̤Ѵ : ž˽
    Vector3 *mpPixelSamplePos;	// Ѵ : ȿͥ쥤ˤ
    double  *mpWeight;		// frustum դγ pixel ФŤ

protected:
    // Υ饹νϥåΰ (¿бȤ櫓Ǥ
    // ʤ) ˡɤɤϤ狼ʤ¿Υեȥ
    // ˤĤƤޤĴ٤Τɤ
    //  enum frustumSRGClass_message {
    // 	frustumSRG_SumpleSquareResolutionIsSmall_e,
    // 	frustumSRG_IllegalFrustumParamInViewfile_e,
    // 	frustumSRG_
    // 	frustumSRG_
    //  };
    //  void outMessage(int messageType);

public:
    frustumSRGClass(void);
    ~frustumSRGClass(void);
    //------------------------------
    // frustum Υ
    //   @param resolBaseSquareEdge frustum դΰդβ 
    void init(int resolBaseSquareEdge);

    //------------------------------
    // ž (0, 0, 1.0)  frustum հֽ
    //   @param frustumTopHalfRad  	 : ĺ/2 (radian)
    //   @param pow_cos_n		 : Phone  cos n § n 
    // Ƥɬ init ɬ
    void setBaseSamplePosition(double halfFrustumTopRad, double pow_cos_n);

    //------------------------------ 
    // rotate base ֤˸ͤ롥 
    //   @param secondRayDir 
    void rotate(const Vector3& secondRayDir);

    //------------------------------ 
    // frustum ĺγ٤ѹž뤿
    // setBaseSamplePosition + rotate  : 嵭2ĤʬΥɬפ
    // 뤫ϸƤ롥Ʊ material ξˤϲžɤȻפ
    // ⤤ʤ褦
    void setTopAngleRadandRotate(double halfFrustumTopRad, 
				 double pow_cos_n,
				 const Vector3& secondRayDir)
    {
	this->setBaseSamplePosition(halfFrustumTopRad, pow_cos_n);
	this->rotate(secondRayDir);
    }

    // ץ֤
    int getTotalSampleNum(void)
    {
	return(this->mNumberOfTotalSamples);
    }

    // i ܤΥץ֤֤
    Vector3 getSamplePixelPos(int i) const
    {
	assert((0 <= i) && (i < this->mNumberOfTotalSamples));
	return(this->mpPixelSamplePos[i]);
    }

    // i ܤΥץνŤߤ֤
    double getWeight(int i)  const
    {
	assert((0 <= i) && (i < this->mNumberOfTotalSamples));
	return(this->mpWeight[i]);
    }
};

#endif
