//------------------------------------------------------------
// $Id: hostVolume.cc,v 1.1.1.1 1999/11/25 06:26:09 yamauchi Exp $
//------------------------------------------------------------
//	(M\pi)^2 host computer implementation for volume 
//	1998/11/17
//	Copyright (C) 1996--1998 YAMAUCHI Hitoshi  
//------------------------------------------------------------
#include "host.h"
#include "mpi2communication.h"
#include "volume.h"


//------------------------------------------------------------
// broadcast NULLVolume to terminate send-receive volumes
//------------------------------------------------------------
void hostComputerClass::
broadNullVolume(int maxNumOfDeliverdVolume)
{
    assert(maxNumOfDeliverdVolume >= 0);

    int x, y, z;
    VolumeClass nullVolume;
    nullVolume.initAsNullVolume();
    for(z = 0; z < (this->mSysInfo.getPEDim()).get(IntVec3::Z); z++)
    {
	for(y = 0; y < (this->mSysInfo.getPEDim()).get(IntVec3::Y); y++)
	{
	    for(x = 0; x < (this->mSysInfo.getPEDim()).get(IntVec3::X); x++)
	    {
		commMpi2_sendVolume(this->getRank(IntVec3(x, y, z)), 
				    &nullVolume); 
	    }
	}
    }
}

