//------------------------------------------------------------
// $Id: myString.cc,v 1.3 2000/05/21 18:43:03 yamauchi Exp $
//------------------------------------------------------------
//  myString.cc and strnew implementation
// 	IBM  IString 饹 string.h, ctype.h ĥΤΤ
//	äơgnu Τ褦 awk δؿ¸ȤͤǤϤʤ
// 	gnu  String 饹 Regex Ȥɽʬ xlC 
// 	ˤäƥѥ뤹뤳ȤϺʤ褦Ǥ롣Ǵ GNU 
// 	 String 饹ȤäƤȤƤϡФФϤ뤬
//	˸ꤵ줿 myString 饹񤯤Ȥˤ
//	GNU ΤΤѤǤΤʤФΥ饹̵ѤǤ롣
//	ޤѤǤʬ GNU libg++-2.7.1 ѤƤ
//	
//	Because in sp2 with AIX3.2, I could not use g++ and GNU libg++,
//	but I want to use them. So, I wrote some code for sp2 based on 
//	GNU gcc and libg++.
//	If you can use gcc and libg++, please use them. Gnu code is
//	best, I think.
//	
//	This class is poor.
//
// 	last change ʿǯ()
// Copyright (C) Hitoshi Yamauchi 1995-1997
// 	* 1997ǯ92() : splitWithWhite ֤ͤ˥Х fix 
//	* 1998ǯ4 4(): splitWithWhite  maxn == 1 λư
//	  ʤХ fix 
//	  #define DEBUG ǥ顼Ϥ褦˽	
//------------------------------------------------------------
//  DEBUG ȥ顼Ϥ롣ä֤ͤΤߤȤʤ
#define DEBUG

// boolian
#ifndef YorN 
enum YorN {
    NO  = 0,
    YES = 1
};
#endif

#include <assert.h>
#include "myString.h"

//------------------------------------------------------------
// strnew 
//------------------------------------------------------------
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>

//------------------------------
// ʸγ
//------------------------------
char *strnew(const char *str)
{
    if(str == NULL)
    {
	cerr << "Error! : can't new (null) at strnew." << endl;
	abort();
	exit(1);
    }
    char *r = NULL;
    r = new char [ strlen(str) + 1 ];
    strcpy(r, str);
    return(r);
}

//------------------------------
// ʸΰβ
//     NULL ϤƤ
//------------------------------
void strdel(char *delstr)
{
    if(delstr != NULL)		//// NULL ξˤϤʤˤ⤷ʤ
    {
	delete [] delstr;
    }
}

//------------------------------------------------------------
// myString
//------------------------------------------------------------
// white space?
//------------------------------
inline static YorN isWhiteSpace(const char ch)
{
    if((ch == ' ') || (ch == '\t') || (ch == '\n'))
    {
        return(YES);
    }else
    {
        return(NO);     
    }
}

// ԤκǸˤ white space 
static void deleteLastWhiteSpace(char *pWork)
{
    int lastIdx = strlen(pWork) - 1;
    while(lastIdx >= 0)
    {
	if(isWhiteSpace(pWork[lastIdx]) == YES)
	{
	    pWork[lastIdx] = '\0';
	}else
	{
	    break;
	}
	lastIdx--;
    }
}

// Ԥκǽˤ white space  skip ݥ󥿤֤
static char * getFirstNonWSchar(char *pStr)
{
    char *pIdx = pStr;
    // cout << "debug: In     getFirstNonWSchar :" << pIdx << ":end" <<	endl;
    while((*pIdx) != '\0')
    {
	if(isWhiteSpace(*pIdx) == NO)
	{
	    break;
	}
	pIdx++;
    }
    // cout << "debug: return getFirstNonWSchar :" << pIdx << ":end" <<	endl;
    return(pIdx);
}

//------------------------------
// char *getOneWord(char **ppStr)
//	ʸκǽζζʬ '\0' 
//	return Ϥ '\0' μʸ³ƤФؤΥݥ
//	
//"  I_Like    Emi Shinohara" -> "  I_Like\0    Emi Shinohara"
//^*ppStr                           ^*ppStr ^return
//------------------------------
static char *getOneWord(char **ppStr)
{
    assert(ppStr     != NULL);
    assert((*ppStr)  != NULL);
    assert((**ppStr) != '\0');
    
    char *pIdx = getFirstNonWSchar(*ppStr);    
    (*ppStr)   = pIdx;

    while((isWhiteSpace(*pIdx) == NO) && ((*pIdx) != '\0'))
    {
	pIdx++;			// Ǥ '\0' Ǥʤ = word; skip
    }
    if((*pIdx) == '\0')
    {
	return(NULL);		// Ǥ˺Ǹ
    }else
    {
	(*pIdx) = '\0';
	pIdx++;
	if((*pIdx) != '\0')
	{
	    return(pIdx);	// ޤ
	}else
	{
	    return(NULL);	// Ǹ˶򤬤ҤȤĤä
	}
    }
}
    
//------------------------------
// split string into array res at separators; return number of elements
//	split  white space Τ
//-----------------------------
int splitWithWhite(const myString& x, myString res[], int maxn)
{
    if(maxn <= 0)
    {
#ifdef DEBUG
	cout << "Error! : maxn [" << maxn << "] must be > 0." << endl;
#endif
	return(0);
    }

    char *pOrg = strnew(x.mpStr); // pOrg[*] Ƥѹ
    deleteLastWhiteSpace(pOrg);
    char *pIdx = pOrg;

    if(strlen(pOrg) == 0)
    {
#ifdef DEBUG
	cout << "Warning! : string has no contensts." << endl;
#endif
	return(0);		// ʤä
    }

    int i;
    // maxn == 1 λˤϼ loop ̤餺(i = 0 νϤ)˺
    // Ƥ
    char *pNext = pIdx;		
    for(i = 0; i < (maxn - 1); i++) // ļޤ
    {
	pNext  = getOneWord(&pIdx);
	res[i] = myString(pIdx);
	if(pNext == NULL)
	{
	    strdel(pOrg);
	    return(i + 1);	// ⤦Ϥʤ i  index ʤΤǸĿ + 1
	}else
	{
	    pIdx = pNext;
	}
    }
    // Ǹ
    assert(pNext != NULL);
    res[i] = myString(getFirstNonWSchar(pNext));
    return(i + 1);
}

//-----------------------------
// get number of words (separator is white space)
//	ñ 
//-----------------------------
int getNumOfWords(const myString& s)
{
    YorN inWord = NO;
    int i; 
    int wc = 0;
    for(i = 0; i < s.mLen; i++)
    {
	if(isWhiteSpace(s.mpStr[i]) == YES)
	{
	    inWord = NO;	// ñǤϤʤ	    
	}else if(inWord == NO)
	{
	    inWord = YES;	// ޤ out word  ñ 
	    wc++;
	}else
	{
	    // ޤ in word  ñ : ʤˤ⤷ʤ
	}
    }
    return(wc);
}

//------------------------------------------------------------
// compare (̾ strcmp  s1 ûˤäƤޤȤ)
//------------------------------------------------------------
static int mystrncmp(const char *str1, const char *str2)
{
    static int len1, len2;
    len1 = strlen(str1);
    len2 = strlen(str2);

    if(len1 != len2)
    {
	return(len2 - len1);	// 0 Ǥʤɤ
    }else
    {
	return(strncmp(str1, str2, len1));
    }
}

int operator==(const myString& x, const myString& y)
{
    return(mystrncmp(x.mpStr, y.mpStr) == 0);
}
int operator!=(const myString& x, const myString& y)
{
    return(mystrncmp(x.mpStr, y.mpStr) != 0);
}
int operator==(const myString& x, const char* t) 
{
    return(mystrncmp(x.mpStr, t) == 0);        
}
int operator!=(const myString& x, const char* t) 
{
    return(mystrncmp(x.mpStr, t) != 0);        
}
int operator==(const char* t, const myString& x) 
{
    return(mystrncmp(x.mpStr, t) == 0);        
}
int operator!=(const char* t, const myString& x) 
{
    return(mystrncmp(x.mpStr, t) != 0);        
}

// concatenation
myString operator+(const myString& x, const myString& y)
{
    myString r = x;  
    r += y;
    return(r);
}

//------------------------------
// output
//-----------------------------
ostream& operator<<(ostream& s, const myString& x)
{
    s << x.chars(); 
    return s;
}

//------------------------------
// test 
//-----------------------------
#ifdef TEST_MYSTRING
int main()
{
    myString s = "    I like   	Megumi Hayashibara and 		Makoto Kino\n";
    cout << "ORG String:::" << s << ":::" << endl;

    int num_of_words = getNumOfWords(s);
    
    myString *pWords = new myString[num_of_words];
    int i;
    cout << "split " << splitWithWhite(s, pWords, num_of_words) << endl;

    for(i = 0; i < num_of_words; i++)
    {
	cout << "split[" << i << "]:::" << pWords[i] << ":::" << endl;
    }
    delete[] pWords;

    myString s1 = s;
    if(s1 == s)
    {
	cout << "match" << endl;
    }else
    {
	cout << "do not match" << endl;
    }
}    
// g++ -DTEST_MYSTRING -Wall -g myString.cc strnew.o
#endif
