//------------------------------------------------------------
// $Id: objectSet.h,v 1.1.1.1 1999/11/25 06:26:09 yamauchi Exp $
//------------------------------------------------------------
// 	object set 
//	(M\pi)^2 
//
//	object  PE ݻݤѤ륯饹
//	˶(Ūʶ֤ǤϤʤΥ饹δ礭
//	 indexΥ饹 PE ΥȥݥʤɤΤʤ)  
//	index ͿȤζ֤°ʪΤ
// 	϶֤®٤Υȥ졼ɥդѲͽ
//	ޤ3ˤ
//	1996/7/16
//	Copyright (C) 1996--1998 YAMAUCHI Hitoshi  
//------------------------------------------------------------
#ifndef _objectSet_h
#define _objectSet_h 1

// #include "material.h"
// #include "mpi2.h"

#include "IntVec3.h"
#include "objectArray.h"


class objectSetClass {
protected:
    IntVec3 		mTotalSpcNum; //  object åȤô֤ο
				      // ʬ (1 / PE )
    objectsArrayClass ***mpppObjArray; // object ؤΥݥ󥿤βĹ:3

protected:
    void delElems(void);
    YorN idxOK(const IntVec3& a3dIdx) const;

public:
    objectSetClass(void) : mpppObjArray(NULL) {}
    ~objectSetClass(void);
    void init(const IntVec3& aTotalSpcNum);

    // a3dIdx ϼºݤζ֤ index
    void setLength(const IntVec3& a3dIdx, int aLen); 
    // lidx  objectSet  index ˤʤ
    void setLengthWithLocalIdx(const IntVec3& localIdx, int aLen); 
    int  getLength(const IntVec3& a3dIdx) const;
    void add(const IntVec3& a3dIdx, objBaseClass* pObj);
    objectsArrayClass *get(const IntVec3& a3dIdx);

    // getStat* : get statistics  object set ξ׻֤
    void getStat(int 	*pNumberOfTotalSpace, // ôֿ
		 double *pAverage,	      // ʪοʿ
		 double *pVariance,	      // ʪοʬ
		 int    *pNoObjectSpaces,     // ʪΤ¸ߤʤֿ
		 // ʪΤ¸ߤʤ֤ʪοʿ
		 double *pNoObjSpaceAverage,  
		 // ʪΤ¸ߤʤ֤ʪοʬ
		 double *pNoObjSpaceVariance); 
};


#endif				// #ifdef _objectSet_h


