//------------------------------------------------------------
// $Id: searchNextSpcDDA.h,v 1.3 2000/05/21 18:43:03 yamauchi Exp $
//------------------------------------------------------------
//	(M\pi)^2 
// 	õ
//	;ޤäǤƤߤФʤΤȤϤʤ
//	Ĥޤ DDA ˥åȤΩι⤤ΤǤ롣
//	1998ǯ127()
//	Copyright (C) 1997--1998 YAMAUCHI Hitoshi  
//------------------------------------------------------------
#ifndef _searchNextSpcDDA_h
#define _searchNextSpcDDA_h 1

#include "mpi2.h"
#include "Vector3.h"
#include "IntVec3.h"
#include "ray.h"
#include "array3d.h"
#include "objectInfoInASpace.h"

//------------------------------------------------------------
// ֤Τ interface ʤɤͤƤ̤Υ饹
//     C++  virtual ʤΤˤ constructor  destructor 
//     ΰ˻롣
//------------------------------------------------------------
// 3DDDA ˡѤõ
//------------------------------------------------------------
class searchNextSpcDDA {
private:
    searchNextSpcDDA(const searchNextSpcDDA& rhs);
    const searchNextSpcDDA& operator=(const searchNextSpcDDA& rhs);

public:				 
    // 3DDDA η׻ɬפȤʤǡ public ʥ
    Vector3  	  mPartVolMin; 	 // DDA ŬѤ֤κǾ
    double   	  mCellLength; 	 // DDA  traverse 륻礭
    int		  mSpcIdxMin[3]; // cell κǾ index (subvolume 
    int		  mSpcIdxMax[3]; // Ʊ index:      Τ0ǾǤϤʤ)
    int      	  mRayPropSkipMethod;// Skip ˡ(Skip 뤷ʤ)
    int 	  mNetworkType;	 // ͥåȥη

    // ʪΤ¸߾
    array3dClass < objectExistInASpaceClass > mObjInSpcMap; 

    // derived values
    double 	  mCellHalf; // cell ĹȾʬ

protected:				 
    void exitIfIllegalParam(double cellLength, const int *pSpcIdxMin, 
			    const int *pSpcIdxMax, 
			    int rayPropSkipMethod, int networkType);

protected:				 
    DIR_3D getDirByDDA(DDAInfoClass *pDInfo);
    void setTraverseAxisNVector(DDAInfoClass* pDInfo, const Vector3& rayDir);
    YorN testCanGo(IntVec3* pSpcPos, DIR_3D dir) const;
    void goNextSpace(IntVec3* pSpcPos, DIR_3D dir) const;
    YorN testAndGoIfItCan(IntVec3* pSpcPos, DIR_3D dir) const
    {
	// ⤷ưǤΤʤ餽˰ưYES ֤
	// Ǥʤˤϰư NO ֤
	if(this->testCanGo(pSpcPos, dir) == YES)
	{
	    this->goNextSpace(pSpcPos, dir);
	    return(YES);
	}else
	{
	    return(NO);
	}
    } 

    // volume ʬȶͭ뤿μõ method
    // ddainfo ˤ뤳Ȥ volume Ǥ subspace Ǥ OK!
    YorN moveRayToNextSubspaceNoSkip(DDAInfoClass *pDinfo, 
				     const Vector3& rayPos,// 
				     const Vector3& rayDir,//٥ȥ
				     IntVec3      *pSpcPos);
    
public:
    searchNextSpcDDA(void);
    virtual ~searchNextSpcDDA(void);

    // ͭϰϤ [SpcIdxMin, SpcIdxMax] Ǥ롥 interface ɤ뤫
    void initWithoutObjInSpcMap(const Vector3& defspcmin, // global defspc min
				double celllen, 
				const int *pSpcIdxMin, 
				const int *pSpcIdxMax,
				int  	   skipMethod,
				int        systemNetworkType);
    void initObjInSpcMap(array3dClass < objectExistInASpaceClass > *pObjMap);
    YorN isObject(const IntVec3& spcpos)
    {
	int spcidx[3];
	spcpos.getAsArray(spcidx);
	return(this->mObjInSpcMap.get(spcidx).isObj());
    }

    void initializeDDA(DDAInfoClass* pDInfo, 
		       const Vector3& rayPos, const Vector3& rayDir,
		       const IntVec3& raySpcPos);

    //  subclass 뤫 interface ˤ٤
    // ϸ
    // ray ΰ֤򼡶֤ѹ : Skip ̵
    YorN moveRayToNextSubspaceNoSkip(Ray *pRay);

    // Ѥʥå
    YorN moveRayWithSobokuSkip(Ray *pRay);
    
    // volume ư
    YorN isValidASpcpos(const IntVec3& spcpos);
    void forceMoveRayToNextSpace(DDAInfoClass *pDinfo, 
				 const Vector3& rayPos, // 
				 const Vector3& rayDir, //٥ȥ
				 IntVec3      *pSpcPos);

};

#endif				// #ifndef _searchNextSpc_h

