/*
 * $Id: CommunBufStatistics.java,v 1.2 1999/11/24 08:40:35 yamauchi Exp $
 *
 *     (M\pi)^2 : CommunBufStatistics
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *	
 * ̿ХåեѤ׾
 *	(֥Ȥ / ) ʿѰ󤢤ꤤ
 *	ĤΥ֥ȤΤ狼롥
 *
 * original source Statistics.h
 *
 * 1999ǯ819()
 */

package jp.ac.tohoku.is.archi.mpi2.net;

import jp.ac.tohoku.is.archi.mpi2.util.*;
import jp.ac.tohoku.is.archi.mpi2.sysparam.*;

/**
 * ̿ХåեѤ statistics
 */
public final class CommunBufStatistics  {
    private int mMaxQueueLen;	// ¦Υ塼Ĺ (¦Τ)
    private int mNSendRecv;	//  or 
    private int mNObjs;		//  or ֥
    
    /**
     * constructor
     */
    public CommunBufStatistics ()
    {
	this.init();
    }
    public CommunBufStatistics(CommunBufStatistics  rhs)
    {
	this.mMaxQueueLen = rhs.mMaxQueueLen;
	this.mNSendRecv   = rhs.mNSendRecv;
	this.mNObjs	  = rhs.mNObjs;
    }

    /**
     * initializer
     */
    public void init()
    {
	this.mMaxQueueLen = 0;
	this.mNSendRecv   = 0;
	this.mNObjs	  = 0;
    }

    /**
     * ˸ߤΥ塼ĹΥ塼ĹϿ롥
     */
    public void reportQueLen(int quelen)
    {
	if(Config.USE_STAT)
	{
	    if(quelen > this.mMaxQueueLen)
	    {
		this.mMaxQueueLen = quelen;
	    }
	}
    }

    /**
     * ä(Ǽ)ʪοεϿ
     */
    public void reportNSendRecvObjs(int n_objes)
    {
	if(Config.USE_STAT)
	{
	    this.mNSendRecv++;
	    this.mNObjs += n_objes;
	}
    }

    /**
     * 
     */
    public int getMaxQueueLen() 	
    {
	return(this.mMaxQueueLen);	
    }

    /**
     * 
     */
    public int getNSendRecv() 	
    {
	return(this.mNSendRecv);	
    }

    /**
     * 
     */
    public int getNObjs() 		
    {
	return(this.mNObjs);		
    }

    /**
     * 
     */
    public double getNObjParSend() 
    {
	if(this.mNSendRecv == 0)
	{
	    return(0.0);	// Ѥʤäˤ 0.0 ֤
	}else
	{
	    return(((double)this.mNObjs) / ((double)this.mNSendRecv));
	}
    }
}

