// -*- mode: Java; file-coding-system: *euc-japan*; -*-
// $Id: Decoder.java,v 1.2 1999/09/22 07:27:07 maeda Exp $
// Copyright (C) 1999 MAEDA Atusi

package jp.ac.tohoku.is.archi.mpi2.util;

/**
 * {@link EncodedData}{@link Encodable}ɤ߽ФΥϥɥ.
 * ɤ߽ФϰʲμǹԤʤ
 * <ol>
 * <li> {@link EncodedData#getDecoder()}Decoder롥
 * <li> {@link #prepare(ObjectDecoder)}ǼǡΤ롥
 * <li> {@link #finishPrepare()}prepareեλХåեդ롥
 * <li> {@link EncodedData#getArray()}Хåե˥ǡ롥
 * <li> {@link #decode(ObjectDecoder)}ǥǡХåեɤ߽Ф
 * </ol>
 * ǡ{@link #prepare(Encodable)}{@link #finishPrepare()}Ѥ
 * ǡ򥻥åȤ뤫ˡ{@link #allocate(int)}Ѥ
 * 쵤˥ХåեդƤɤ
 */

public interface Decoder {
  /**
   * ͽΥǡ1Τ.
   * ObjectDecoderͽ¬ǤˤΤѤ뤳ȤǤ롥
   * @param od ͽΥǡǥɤǤObjectDecoder
   * @see #finishPrepare
   */
  public void prepare(ObjectDecoder od);

  /**
   * {@link prepare(ObjectDecoder)}򷫤֤ΤǸˤΥ᥽åɤ
   * ѤƼѥХåեդ롥
   * @see #prepare
   * @see #allocate
   */
  public void finishPrepare();

  /**
   * ꤷ礭μѥХåեդ.
   * Ʊ礭Υ֥ȤѤ롥
   * {@link ObjectDecoder}ǻꤷnelemĤ֤󷫤֤礭
   * Хåեդ롥
   *
   * @param decoder 1ĤǤ礭ꤹObjectDecoder
   * @param nelem ǿ
   * @see #finishPrepare
   */
  public void allocate(ObjectDecoder decoder, int nelem);

  /**
   * ꤷ礭μѥХåեդ.
   *
   * @param size Хåե礭(ǿ)
   * @see #finishPrepare
   */
  public void allocate(int size);

  /**
   * Хåե顤ǡ1ɤ߽Ф֤.
   * @param od ΥǡǥɤǤObjectDecoder
   */
  public Object decode(ObjectDecoder od);
}
