/*
 * $Id: FileUtil.java,v 1.4 2000/06/15 13:55:51 yamauchi Exp $
 *     (M\pi)^2 : FileUtil (file utility) 
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	Copyright 1999 MAEDA Atusi
 *	@author YAMAUCHI Hitoshi, MAEDA Atusi
 *
 * 	FileUtil : ʰץե
 *
 * original source fileUtil.h
 * 
 * 1999ǯ817()
 */

package jp.ac.tohoku.is.archi.mpi2.util;

import java.io.*;
import jp.ac.tohoku.is.archi.mpi2.sysparam.*;

/**
 * ʰץեط
 */
public final class FileUtil implements Mpi2Constants {
    /**
     * ե뤬¸ߤˤ temp filename ֤
     *   temp file ˻Ѥ File.createTemp ˤ prefix  
     *   suffix ϤΤprefix  Mpi2Constants ǷƤ롥
     *   suffix ΤߤϤtemp file ̾ǥե뤬ߤʤ
     *    suffix = null ȤƤ
     *
     *      @param candidateWriteFname write  open ե̾
     *      @param suffix temp filename  suffix 
     *      @return open  FileԤˤ null ֤롥
     */
    public static File newUniqueWriteFP(String candidateWriteFname, 
					String suffix)
    {
	// file ¸ߤ뤫ǧ
	File f = new File(candidateWriteFname);
	if(!(f.exists()))
	{
	    // ե¸ߤʤΤޤ֤
	    return(f);
	}

	// ե뤬¸ߤ롥
	if(suffix == null)
	{
	    String s = "Error! : file exist and you ordered never create " +
		"tmpfile. return (File)null, cadidate = "+ candidateWriteFname;
	    System.out.println(s);
	    // ¾ tmp ʤ褦˻ؼ
	    return(null);
	}

	// ե뤬¸ߤ tmp file 
	System.out.println("Warning! : There is [" + candidateWriteFname +
			   "]. " + "I will try to create new filename.");

	// try to make temporary file

	/* 
	    for JDK1.2 
		FIXME
	try {
	    f = File.createTempFile(TEMP_SAVEIMAGE_FILEPREFIX, suffix);
	}catch(IOException e)
	{
	    System.out.println("Error! : Can not create tempfile. " + 
			       "FileUtil.getUniqueWriteFP\n" + e);
	}catch(Exception e)
	{
	    System.out.println("Error! : ??? FileUtil.getUniqueWriteFP\n" + e);
	}

	System.out.println("mktmp succeeded. temp filename is ["+
			   f.getName() + "] instead of [" + 
			   candidateWriteFname + "] by File.createTempFile.");
	*/
	return(f);
    }

    /*
     * test 
     */
    public static void main(String [] args)
    {
	System.out.println("If file is exist, return tempfilename.");	
	File f = newUniqueWriteFP(args[0], ".tmp");
	System.out.println(f.getName());
    }
}
