//------------------------------------------------------------
// $Id: mpi2.h,v 1.2.2.1 2000/06/14 15:00:11 yamauchi Exp $
//------------------------------------------------------------
//	mpi2.h
//	1996/3/17 
//	(C) Copyright Hitoshi YAMAUCHI
//------------------------------------------------------------
#ifndef _mpi2_h
#define _mpi2_h 1

// 
#define NIN " Not implemented now\n"

//------------------------------------------------------------
// boolian 
//------------------------------------------------------------
#include "YorN.h"

//------------------------------------------------------------
// SLList.h  queue ɤ򼨤ͤ̾Ĥ
//------------------------------------------------------------
enum queue_stat_e {
    Q_NOT_EMPTY = 0		
};

//------------------------------------------------------------
// rendering ˡ
//------------------------------------------------------------
enum renderingMethod_e {
    Radiosty_render,
    RayTracing_render,
    ELSE_render
};

//------------------------------------------------------------
// ֤ allocation scheme
//------------------------------------------------------------
enum allocScheme_e {
    Block_Alloc,
    Distributed_Alloc,
    Skewed_Alloc,
    Random_Alloc,
    ELSE_Alloc
};

//------------------------------------------------------------
// Shading Scheme
//------------------------------------------------------------
enum shadingScheme_e {
    FlatShading,
    GouroudShading,
    ELSE_Shading
};

//------------------------------------------------------------
// Ray propagation method (skip method)
//------------------------------------------------------------
enum rayprop_skip_method_e {
    NoSkip_rayprop,
    SobokuSkip_rayprop,
    ProximityClouds_rayprop,
    ELSE_rayprop
};

//------------------------------------------------------------
// Map generation method for proximity clouds method 1999ǯ216()
//------------------------------------------------------------
enum mapgen_method_4_PRC_e {
    NoPRC_mapgen,
    ReadMap_mapgen,
    GenerateMap_mapgen,    
    ELSE_mapgen
};

//------------------------------------------------------------
// Network type
//------------------------------------------------------------
enum network_type_e {
    Torus_network,
    MultiStage_network,
    ELSE_network
};

//------------------------------------------------------------
// first ray generation method in ray-tracing
//------------------------------------------------------------
enum frgRayGenMethod_e {
    AllScan_frgm,		// frgm ... Frg unit's Ray Generation Method
    ScanlineScan_frgm,
    DistributedScan_frgm,
    ELSE_frgm
};

//------------------------------------------------------------
// for communication tags (1  1 ̿ˤåμ򼨤)
//------------------------------------------------------------
enum communication_tags_e {
    TAG_RAY_e, 			// 
    TAG_INTENSITY_e, 		// پ
    TAG_HOST_COM_e, 		// Host 楳ޥ : Host -> PE   
    TAG_PE_STATUS_e, 		// PE Ư 	       : PE   -> Host 
    TAG_INT_VER_e, 		// ٤ĺξ(shading Ԥ)
    //----- Object
    // fixed size object (with change commMpi2_canRecvObject)
    TAG_TRIANGLE_OBJ_e,		// ѷʪ
    TAG_SPHERE_OBJ_e,		// 
    // variable size object
    TAG_VOLUME_OBJ_e,		// volume 
    // Null object
    TAG_NULL_OBJ_e		// Null object(ɤ object Ǥʤ object)
};

//------------------------------------------------------------
// ʬФ̾
//------------------------------------------------------------
enum DIR_3D {
    DIR_XPLUS,
    DIR_XMINUS,
    DIR_YPLUS,
    DIR_YMINUS,
    DIR_ZPLUS,
    DIR_ZMINUS,
    DIR_HERE,                   // ʬ
    DIR_3D_NUM,
    DIR_ILLEGAL                 // ꤨʤͤȤƻѤ
};

//------------------------------------------------------------
// ʪΤν
//------------------------------------------------------------
enum Object_OutputType_e {
    NORMAL_ObjOut_e,
    WITH_SHOT_RADOUT_e,    
    WITH_UNSHOT_RADOUT_e
};

#endif				// #ifndef _mpi2_h
