#!/bin/sh -x
#
#	test for 4tri and small volume 
#		YAMAUCHI Hitoshi 
#

#------------------------------------------------------------
# no volume rendering (4tri)
#------------------------------------------------------------
#./mpi2 -Sv -fspc ../../../data/testMpi2Data/4tri.mpi2.spc -fmat ../../../data/testMpi2Data/4tri.mpi2.mat -fgeo ../../../data/testMpi2Data/4tri.mpi2.geo -fsys sysinfo.sample -fview ../../../data/testMpi2Data/4tri.mpi2.view -fsaveppm save.out
#exit
#------------------------------------------------------------
# no volume rendering (2tri)
#------------------------------------------------------------
#./mpi2 -Sv -fsys sysinfo.sample -fsaveppm save.ppm                                         -fspc  ../../../data/testMpi2Data/2tri.mpi2.spc                                -fmat  ../../../data/testMpi2Data/2tri.mpi2.mat                                -fgeo  ../../../data/testMpi2Data/2tri.mpi2.geo                                -fview ../../../data/testMpi2Data/2tri.mpi2.view

#exit
#------------------------------------------------------------
# no volume rendering (room16)
#------------------------------------------------------------
./mpi2 -fsys sysinfo.sample -fsavegfb save.gfb                                         -fspc  ../../parallelMpi2_old/data/sph.s64.mpi2.spc                              -fmat  ../../parallelMpi2_old/data/sph.s64.mpi2.mat                              -fgeo  ../../parallelMpi2_old/data/sph.s64.mpi2.geo                              -fdis  ../../parallelMpi2_old/data/sph.s64.mpi2.map                              -fview ../../parallelMpi2_old/data/vi.gl.cor

exit

#------------------------------------------------------------
# for volume rendering test
#------------------------------------------------------------
# ./mpi2 -Sv -fspc ../../../data/testMpi2Data/4tri.mpi2.spc -fmat ../../../data/testMpi2Data/4tri.mpi2.mat -fgeo ../../../data/testMpi2Data/4tri.mpi2.geo -fsys sysinfo.sample -fvinl ../../test/dividedvol/sample.volin.list -fview ../../../data/testMpi2Data/4tri.mpi2.view -fsaveppm save.out

#------------------------------------------------------------
# only for volume rendering test
#------------------------------------------------------------
# ./mpi2 -Sv -fspc ../../../data/testMpi2Data/4tri.mpi2.spc -fsys sysinfo.sample -fvinl ../../test/dividedvol/sample.volin.list -fview ../../../data/testMpi2Data/4tri.mpi2.view -fsaveppm save.out


#------------------------------------------------------------
# for volume rendering test for `Head'
#------------------------------------------------------------
# ./mpi2 -Sv -fspc ../../../data/volumedata/3Dhead_pgm/head.spc -fsys sysinfo.sample -fvinl ../../../data/volumedata/3Dhead_pgm/head.volin.list -fview ../../../data/volumedata/3Dhead_pgm/head.view -fsaveppm save.out

./mpi2 -Sv -fspc ../../../data/volumedata/3Dhead_pgm/head.spc -fsys sysinfo.sample -fvinl ../../../data/volumedata/3Dhead_pgm/head.volin.list2 -fview ../../../data/volumedata/3Dhead_pgm/head.view -fsaveppm save.out

