//------------------------------------------------------------
// $Id: PRC_deliverSkipInfo.cc,v 1.2 2000/05/19 20:35:51 yamauchi Exp $
//------------------------------------------------------------
//	(M\pi)^2 host computer implementation
//	1998/8/25 
//	Copyright (C) 1998 YAMAUCHI Hitoshi   
//			   TOKUNAGA Mayumi   ͳ
//
// skip ˡɽۤϤ
//  : void hostComputerClass::readAndDeliverObjectData(void)
//------------------------------------------------------------
#include "host.h"
#include "mpi2_funcs.h"
#include "PRC_searchNextSpc.h"
#include "mpi2communication.h"

void hostComputerClass::
PRC_deliverSkipInfoMap(const char  *pDistanceFname)
{
    // ɤΤɤΤ YAMAUCHI 1998ǯ827()
    array3dClass < PRC_skipMapClass > objDistanceMap;
    int size1d[3];
    size1d[0] = size1d[1] = size1d[2] = this->mSpcParam.getSubDivNum();
    objDistanceMap.initBySizeWithBaseZero(size1d);

    // defspcnumѻߤ줿Τǡ¿ʬХ 2000ǯ519()
    IntVec3 defspcnum = this->mSpcParam.getMaxDefSpcIdx();
    OBJINSPC_IMPLEMENT_TYPE *pSkipDatArray = 
	new OBJINSPC_IMPLEMENT_TYPE [objDistanceMap.getTotalSize()];

    if(readDistanceDataInfo(pDistanceFname, &defspcnum, 
     			    pSkipDatArray, size1d[0]) == NO )
    {	
	cout << "Error! : can not read ditance file." << endl;
	commMpi2_exit(1);
    }
    else
    {
	commMpi2_BroadPRCSkipMap(sizeof(OBJINSPC_IMPLEMENT_TYPE) * 
				 objDistanceMap.getTotalSize(),
				 pSkipDatArray); 
	delete [] pSkipDatArray;
    }
}
