//------------------------------------------------------------
// $Id: PRC_searchNextSpc.h,v 1.1.1.1 1999/11/25 06:26:09 yamauchi Exp $
//------------------------------------------------------------
//	(M\pi)^2 
// 	õ
//	Copyright (C) 1998 Mayumi TOKUNAGA	 ͳ
//			   Hitoshi YAMAUCHI 	 
//------------------------------------------------------------
#ifndef _searchNextSpcPRC_h
#define _searchNextSpcPRC_h 1

#include "searchNextSpcDDA.h"

//------------------------------
// Proximity Clouds ˡǻȤ Skip Map 
//	YAMAUCHI 1998ǯ827() 
// objectInfoInASpace.h Ѥ skip ѤΥޥåפǤ
//	objectInfoInASpace.h ˤʪο(׽)Τȡʪ
//	ΤΤʤ(Ѥ skip )  2 Ĥμ㤬ޤ
//------------------------------
class PRC_skipMapClass {  
protected:    
    OBJINSPC_IMPLEMENT_TYPE mSkipDistance;

public:    
    // constructors
    PRC_skipMapClass(void) : mSkipDistance(0){}
    PRC_skipMapClass(const PRC_skipMapClass& rhs)
    {
	this->mSkipDistance = rhs.mSkipDistance;
    }
    PRC_skipMapClass(const OBJINSPC_IMPLEMENT_TYPE& rhs)
    {
	this->mSkipDistance = rhs;
    }
    const PRC_skipMapClass operator=(const PRC_skipMapClass& rhs)
    {
	if(this != &rhs)
	{
	    this->mSkipDistance = rhs.mSkipDistance;
	}
	return(*this);
    }

    void set(int distance) 
    {
	// ɽ char ʤΤ 127 ޤǤʤ
	assert((distance >= 0) && (distance < 128));
	this->mSkipDistance = distance;
    }
    int get(void) const
    {
	return(this->mSkipDistance);
    }

    // for serialize (Τ OBJINSPC_IMPLEMENT_TYPE ǼФ)
    OBJINSPC_IMPLEMENT_TYPE getObjInfo(void) const
    {
	return(this->mSkipDistance);
    }
    
    friend ostream& operator<<(ostream& s, PRC_skipMapClass& onis)
    {
	s << onis.mSkipDistance;
	return s;
    }

    // operator ==
    friend int operator==(const PRC_skipMapClass &a,
			  const PRC_skipMapClass &b)
    {
	return(a.mSkipDistance == b.mSkipDistance);
    }
    friend int operator!=(const PRC_skipMapClass &a,
			  const PRC_skipMapClass &b)
    {
	return(a.mSkipDistance != b.mSkipDistance);
    }
    
    //----------------------------------------
    // SerializableIF : double ɽƱ׻ǤʤȾ꤯ʤ    
    //----------------------------------------
    int getSerializedSize(void) const
    {
	// OBJINSPC_IMPLEMENT_TYPE mObjInfo;  char 
	return(1);
    }
    double *newSerializedArray(void)
    {
	double *r = new double[this->getSerializedSize()];
	r[0] = (double)(this->mSkipDistance);
	return(r);
    }
    void deserialize(double *pBuf)
    {
	this->mSkipDistance = (char)(pBuf[0]);
    }

    // for pretty print () 
    // Υ饹ϵΥϤȤ¾ΤΤʪΤΤʤ
    // ꤷƤ롥objectInfoInASpace.h 򻲾ȤΤȡ
    const char * getVisualOutDescription(void) const
    {
	return(" Distance");	// : Υ֤Ȥ̣
    }
    int getVisualOut(void) const
    {
	return(this->mSkipDistance);
    }
};

//------------------------------
// Proximity Clouds ˡѤ DD Unit
//------------------------------
class searchNextSpcPRC : public searchNextSpcDDA {
private:
    searchNextSpcPRC(const searchNextSpcPRC& rhs);
    const searchNextSpcPRC& operator=(const searchNextSpcPRC& rhs);

protected:
    IntVec3 getSpcByPRC(const int skipnum, DDAInfoClass *pDInfo);
    YorN testCanGo(IntVec3* pSpcPos, IntVec3 relapos);
    IntVec3 getNextSubspaceRelative(const int skipnum, DDAInfoClass *ddainfo,IntVec3 spcpos);
    void goNextSpacePRC(IntVec3* pSpcPos, IntVec3 relapos) const;
    YorN testAndGoIfItCan(IntVec3* pSpcPos, IntVec3 relapos) 
    {
	// ⤷ưǤΤʤ餽˰ưYES ֤
	// Ǥʤˤϰư NO ֤
	if(this->testCanGo(pSpcPos, relapos) == YES)
	{
	    this->goNextSpacePRC(pSpcPos, relapos);
	    return(YES);
	}else
	{
	    return(NO);
	}
    }
public:    
    searchNextSpcPRC(void);
    ~searchNextSpcPRC(void);
    YorN moveRayToNextCalcSubspaceWithSkip(Ray *pRay);

public:    
    array3dClass < PRC_skipMapClass > mObjInSpcMap; 
    //PRC_skipMapClass mObjInSpcMap;
    YorN isObject(const IntVec3& spcpos)
    {
	int idx[3];
	spcpos.getAsArray(idx);
	if(this->mObjInSpcMap.get(idx).get() == 0)
	    return(YES);
	else
	    return(NO);

    }

};






#endif				// #ifndef _searchNextSpc_h

