#! /bin/sh
#
#  $Id: linkformpi.sh.in,v 1.1.2.1 2000/07/02 15:55:08 yamauchi Exp $
#	Copyright (C) 1997-2000 YAMAUCHI Hitoshi  
#
TESTPROG=/opt/gnu/bin/test

HEADERS="DLList.h	\
GridColor.h		\
HostComm.h		\
Intensity.h		\
NetIntUnit.h		\
PE.h			\
PEStat.h		\
PEpmarray.h		\
Pix.h			\
PRC_searchNextSpc.h	\
ProcObj.h		\
RecvBuffer.h		\
SendBuffer.h		\
Statistics.h		\
adjdir.h		\
array3d.h		\
calcRayTrSRGgetdir.h	\
frameBuffer.h		\
frustumSRG.h		\
hemicube.h		\
host.h			\
materialArray.h		\
mpi2communication.h	\
mySLQueue.h		\
objectArray.h		\
objectInfoInASpace.h	\
objectSet.h		\
outputObjectSize.cc	\
pnmReader.h		\
rayTrFRGUnit.h		\
screenPointer.h		\
searchNextSpcDDA.h	\
spc2PE.h		\
stopwatch.h		\
sysinfo.h		\
viewdata.h		\
volume.h		\
volumeFuncs.h		\
volumeGridInfo.h	\
volumeInfile.h		\
volumeSet.h		\
FileInfo.h		\
IntVec3.h		\
Option.h		\
Vector3.h		\
VertexIntensity.h	\
YorN.h			\
constants.h		\
ddaInfo.h		\
getvals.h		\
lineParser.h		\
material.h		\
mpi2.h			\
mpi2ReaderClass.h	\
mpi2_funcs.h		\
mpi2dataToken.h		\
mpi2exit.h		\
myString.h		\
object.h		\
ray.h			\
SpaceParam.h		\
sphereObject.h		\
strnew.h		\
triangleObject.h	\
vector.h		\
voltravinfo.h"

FILES="NetIntUnit.cc	\
PE.cc			\
PEGetNextSpace.cc	\
PERadiosity.cc		\
PERayTracing.cc		\
PEvolume.cc		\
PRC_deliverSkipInfo.cc	\
PRC_readDistInfo.cc	\
PRC_searchNextSpc.cc	\
boundtest.cc		\
calcRadioFRG.cc		\
calcRadioIC.cc		\
calcRadioSRG.cc		\
calcRayTrFRG.cc		\
calcRayTrIC.cc		\
calcRayTrSRG.cc		\
calcRayTrSRGDist.cc	\
ddaInfo.cc		\
deliverVolume.cc	\
frameBuffer.cc		\
frustumSRG.cc		\
hemicube.cc		\
host.cc			\
hostVolume.cc		\
objectDatas.cc		\
objectSet.cc		\
pnmReader.cc		\
prepareShading.cc	\
readSysinfo.cc		\
readView.cc		\
readVolumeInfile.cc	\
searchNextSpcDDA.cc	\
spc2PE.cc		\
volume.cc		\
volumeInit.cc		\
volumeRayCast.cc	\
volumeReader.cc		\
volumeSerializable.cc	\
volumeSet.cc		\
hostNetIntUnit.cc	\
ElapsedTimer.h		\
FileInfo.cc		\
ProfileMon.h		\
fileUtil.cc		\
getopt.cc		\
getvals.cc		\
lineParser.cc		\
material.cc		\
mpi2ReaderClass.cc	\
myString.cc		\
ray.cc			\
sphereObject.cc		\
triangleObject.cc	\
vector.cc		\
readSpcParam.cc"

for i in ${HEADERS} ${FILES}
do
    if ${TESTPROG} ! -L ${i} ; then
	if ${TESTPROG} -f ../mpi2dataReader/${i} ; then
	    ln -s ../mpi2dataReader/${i} .
	elif ${TESTPROG} -f ../1PE/${i} ; then
	    ln -s ../1PE/${i} .
	else
	    echo "Error! : I can not find [${i}]. This is R2mark error."
	    exit 1;
	fi
    fi
done
echo "link ... done"
exit 0	    