#!/bin/sh -x
#
#
rm save.out

if [ $# != 1 ] ; then 
	echo "Usage: ./tessol.sh [num]"
	exit;
fi

starttime=`date`
datadir=../../../data/testMpi2Data

machinefile=./machines.sol

mpi2option=-dv
# mpi2option=-vs

file=4tri.mpi2
# file=room16.mpi2

# volume and geometry ξ
mpirun -machinefile $machinefile -np $1 ./mpi2 $mpi2option -fspc $datadir/$file.spc -fmat $datadir/$file.mat -fgeo $datadir/$file.geo -fsys sysinfosamples/sysinfo.sample$1 -fview $datadir/$file.view -fvin ../../../data/volumedata/sampledat/4tri.volinlist -fsaveppm save.out

# geometry
# mpirun -machinefile $machinefile -np $1 $mpirunoption ./mpi2 $mpi2option -fspc $datadir/$file.spc -fmat $datadir/$file.mat -fgeo $datadir/$file.geo -fsys sysinfosamples/sysinfo.sample$1 -fview $datadir/$file.view -fsaveppm save.out

# volume
# mpirun -machinefile $machinefile -np $1 $mpirunoption ./mpi2 $mpi2option -fspc $datadir/$file.spc -fsys sysinfosamples/sysinfo.sample$1 -fview $datadir/$file.view -fvin ../../../data/volumedata/sampledat/4tri.volinlist -fsaveppm save.out

echo "start time = $starttime"
echo "end   time = `date`"
