/*
 * $Id: PEStatistics.java,v 1.2 2000/06/15 13:55:48 yamauchi Exp $
 *
 *     (M\pi)^2 : PE statistics 
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *	
 * PE ط׾ : 
 *	PEStat (PE Status Ȥޤ路)
 *
 * original source Statistics.h
 *
 * 1999ǯ822()
 */

package jp.ac.tohoku.is.archi.mpi2.common;

/**
 * PE ˤĤƤ׾
 */
public final class PEStatistics  {
    /*
     * HemiCube 
     */
    private int mNumberOfGenHC;	
    
    /**
     * constructor
     */
    PEStatistics()
    {
	this.init();
    }

    /**
     * initializer
     */
    public void init()
    {
	this.mNumberOfGenHC = 0;
    }

    /**
     * HemiCube õϿ
     */
    public void incHCGenNum() 		
    {
	this.mNumberOfGenHC++;	
    }

    /**
     * HemiCube õϿ
     */
    public int  getHCGenNum()
    {
	return(this.mNumberOfGenHC);	
    }

    public String toStringWithHead(String headder)
    {
	String ret = headder + " total generated number of HCs " +
	    this.mNumberOfGenHC;
	return(ret);
    }
}

