/*
 * $Id: ReadFileTest.java,v 1.2 1999/11/25 06:46:26 yamauchi Exp $
 *     (M\pi)^2 : Read File Test for 1PE 
 *	Copyright (C) 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *	
 * 1999ǯ1124()
 */

package jp.ac.tohoku.is.archi.mpi2.host;

import  java.io.*;
import  jp.ac.tohoku.is.archi.mpi2.sysparam.*;
import  jp.ac.tohoku.is.archi.mpi2.util.*;

/**
 * read files 
 */
public final class ReadFileTest 
implements Mpi2Constants, Mpi2Enum 
{
    /**
     * read files main
     */ 
    public static void main(String [] args) 
    {
	Mpi21PE.initCommunicator(args);

	Mpi21PE.analyzeCommandLine(args);

	if((Mpi2Option.getInstance()).getDebugMode())
	{
	    System.out.println((Mpi2Option.getInstance()).
			       toStringWithHead("//"));
	    System.out.println(FileInfo.getInstance().toStringWithHead("//"));
	}
	(Host.getInstance()).init(1);
	ElapsedTimer et = new ElapsedTimer();
	et.start();
	(Host.getInstance()).readAndDeliverAllData();
	et.stop();
	System.out.println("Read Elapsed time = " + et.getTotalTime() + " ms");
    }
}



