/*
 * $Id: ObjectPrimitive.java,v 1.10 2000/06/15 13:55:51 yamauchi Exp $
 *     (M\pi)^2 : ObjectPrimitive
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *	
 * original source object.h
 * 
 *-- 1999ǯ728() Ĥ󤬤θ˲ää
 * Υ饹̾ object ʤΤǤΤޤѤǤʤ
 * ʪΤˤĤƤɤʤΤǤٽľƤߤ롥
 * 
 * ϥѥå primitive ʤɤˤư㤦ǥ쥯ȥ٤
 * ǤȤˤ Java ؤΤΤޤޤѴ׻뤹롥 
 *
 * ʪ ID ɲä TriangleObject ǤѤʤ⤷
 * ʤ1999ǯ12 8()
 */

package jp.ac.tohoku.is.archi.mpi2.obj;

import java.lang.String;
import jp.ac.tohoku.is.archi.mpi2.util.Vector3;
import jp.ac.tohoku.is.archi.mpi2.util.IntVec3;
import java.io.Serializable;

/**
 * <code>ObjectPrimitive<code> interface represents object behavior.
 *
 * @author 	YAMAUCHI Hitoshi ()
 */
public abstract class ObjectPrimitive 
implements Serializable
{
    /*
     * object identifier 
     */
    public final static int OBJ_TRIANGLE 	= 0;
    public final static int OBJ_SPHERE 		= 1;
    public final static int OBJ_NULL		= 2;

    //
    private int  	mObjectID;	// ʪΤ ID (Shading )
    private int  	mMaterialID;	// ʪΤ material  ID
    private IntVec3	mSpcPos;   	// ʬ֤ΰ
    

    /**
     * constructor
     */
    public ObjectPrimitive(int objID, int matID, IntVec3 spcpos)
    {
     	this.mObjectID 	  = objID;
     	this.mMaterialID  = matID;
	this.mSpcPos 	  = new IntVec3(spcpos);
    }

    /**
     * object ID μФϻѷˤפ?
     */
    public final int getObjectID()
    {
	return(this.mObjectID);	
    }

    /**
     * material μФ material ̾ﶦͭƤ롥
     */
    public final int getMaterialID()
    {
	return(this.mMaterialID);	
    }

    /**
     * ʬְ
     */
    public final IntVec3 peekSpcPos()
    {
	return(this.mSpcPos);	
    }

    /**
     * ʪΤޤǤεΥ(if ret PlusInfty =  not hit)
     *  @param  ray 		ƥȤ ray 
     *  @param  hitPositionRef 	Ф Vector3 ֤
     * 	@return ʪΤޤǤεΥ
     */
    public abstract double getDistance(Ray aRay, Vector3 hitPositionRef);
    
    // shading Τε٤֤(flat and shaded color)
    public abstract Vector3 newFlatRadiosityColor(Vector3 hitPos);
    public abstract Vector3 newShadedRadiosityColor(Vector3 hitPos);

    // ʪΤˡ٥ȥ֤ arg = void ѤǤʤ object 
    // public abstract Vector3 peekNormal();
    public abstract Vector3 peekNormal(Vector3 hitpos);

    // identifier
    public abstract String toStringWithHead(String headder);
    public abstract String getMgfForm(int type);
    public abstract int who();

    /**
     * ʬ֤¸ߤƤΤ 
     * @return ֤ˤ true 
     */
    public abstract boolean isAtValidSpcPos(Vector3 partmin, 
					    Vector3 subSpcSize, 
					    int subduvnum);
}
