/*
 * $Id: PixelPointer.java,v 1.2 2000/06/15 13:55:51 yamauchi Exp $
 *     (M\pi)^2 : PixelPointer 
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *
 *	RayTracing ǤνʬΤ pixel pointer
 *	
 * original source screenPointer.h
 *
 *	pixel pointer class 
 *	    scan type : allscan 	̤֤˥󤹤
 *			scanlinescan 	scanline  PE ˳Ƥ
 *			distributedscan	distributed  PE سƤ
 *	쥤ȯ screen  pixel 򥹥󤹤
 *	
 * ֥ȶʬ䷿׻ǥ˴Ť׻Ǥνʬ
 * ιͤ 1997 δǷˤäƤ졢ǽδǷˤäƼ
 * 줿. ķμǤϡ#ifdef ˤäڤ괹Ƥᡤѹ
 * θ̤򸫤ˤϥѥ뤷ʤɬפǤäϤ
 * ư褦 rewrite    
 *
 * 1999ǯ8 6()
 */

package jp.ac.tohoku.is.archi.mpi2.raytrace;

/**
 * screen  pixel ֤ݻΰ֤ȯ PixelPointer  
 * Interface 
 */
public abstract class PixelPointer  {
    protected int mMaxX;	// screen max X
    protected int mMaxY;	// 	      Y
    protected int mX;		// ߤ screen  X
    protected int mY;		// 		      Y
 
    public PixelPointer()
    {
	this.mMaxX	= -1;
	this.mMaxY 	= -1;
	this.mX 	= -1;
	this.mY 	= -1;
    }
    
    /**
     * ʬ scan type ֤
     */
    public abstract String getScreenPointerType();

    /**
     *  pixel ֤Ф
     */
    public abstract boolean next();

    /**
     *  screen ֤Ф
     */
    public int getPixelPosX()
    {
	return(this.mX);
    }
    public int getPixelPosY()
    {
	return(this.mY);
    }
}

