/*
 * $Id: Mpi2Enum.java,v 1.11 2000/06/15 13:55:51 yamauchi Exp $
 *     (M\pi)^2 : enumeration for (M\pi)^2
 *	Copyright 1999 By YAMAUCHI Hitoshi   
 *	@author YAMAUCHI Hitoshi  
 *
 * 	Mpi2Enum : some selectable name set
 *
 *-- 1999ǯ8 3()
 *-- ꡤĴޤǻ䤬äƤ⤤Τ
 *-- ʤȻפäƤΤ
 */

package jp.ac.tohoku.is.archi.mpi2.sysparam;

/**
 * Mpi2Enum : global constants for (M\pi)^2
 */
public interface Mpi2Enum {
    /**
     * rendering ˡ
     */
    public static final int Radiosty_render	= 0;
    public static final int RayTracing_render	= 1;
    public static final int ELSE_render		= 2;

    /**
     * Allocation Scheme
     */
    public static final int Block_Alloc 	= 0;
    public static final int Distributed_Alloc	= 1;
    public static final int Skewed_Alloc	= 2;
    public static final int Random_Alloc	= 3;
    public static final int ELSE_Alloc		= 4;

    /**
     * Shading scheme 
     */
    public static final int FlatShading		= 0;
    public static final int GouroudShading	= 1;
    public static final int ELSE_Shading	= 2;

    /**
     * Ray propagation method (skip method)
     */
    public static final int NoSkip_rayprop		= 0;
    public static final int SobokuSkip_rayprop		= 1;
    public static final int ProximityClouds_rayprop	= 2;
    public static final int ELSE_rayprop		= 3;

    /**
     * Map generation method for proximity clouds method
     */
    public static final int NoPRC_mapgen		= 0;
    public static final int ReadMap_mapgen		= 1;
    public static final int GenerateMap_mapgen   	= 2;
    public static final int ELSE_mapgen			= 3;

    /**
     * Network type
     */
    public static final int Torus_network		= 0;
    public static final int MultiStage_network		= 1;
    public static final int ELSE_network		= 2;

    /**
     * first ray generation method in ray-tracing
     *   frgm ... Frg unit's Ray Generation Method
     */
    public static final int AllScan_frgm		= 0;
    public static final int ScanlineScan_frgm		= 1;
    public static final int DistributedScan_frgm	= 2;
    public static final int ELSE_frgm			= 3;

    /**
     * for communication tags (1  1 ̿ˤåμ򼨤)
     */
    public static final int TAG_RAY	  = 0; 	// 
    public static final int TAG_INTENSITY = 1; 	// پ
    public static final int TAG_HOST_COM  = 2;	// Host 楳ޥ:Host->PE
    public static final int TAG_PE_STATUS = 3;	// PE Ư 	      :PE->Host
    public static final int TAG_INT_VER	  = 4;	// ٤ĺξ(shading)
    //----- Object
    // fixed size object (with change commMpi2_canRecvObject)
    public static final int TAG_TRIANGLE_OBJ = 5; // ѷʪ
    public static final int TAG_SPHERE_OBJ   = 6; // 
    // variable size object
    public static final int TAG_VOLUME_OBJ   = 7; // volume 
    // Null object (ɤ object Ǥʤ object)
    public static final int TAG_NULL_OBJ     = 8;
    public static final int TAG_INTEGER      = 9;
    public static final int TAG_ELSE         = 10;
    public static final String [] TAG_STR = {
	"Ray", "Intensity", "HostCom", "PEStat", "IntVer", 
	"Triangle", "Sphere", "Volume", "NullObj", "int", "else"
    };

    
    /**
     * ʪΤνˡ (ѥå)
     */
    public static final int NORMAL_ObjOut	= 0;
    public static final int WITH_SHOT_RADOUT	= 1;
    public static final int WITH_UNSHOT_RADOUT	= 2;

    /**
     * HemiCube Υ쥤ˡ
     */
    //     public static final int CONTINUOUS_Rayout_OnHC	= 0;
    //     public static final int DISTRIBUTED_Rayout_OnHC	= 1;
    //     public static final int ELSE_Rayout_OnHC		= 2;    

    /**
     * (M\pi)^2 Υߥ˥μ̻
     */
    public static final int MPI2COMM_OnePE		= 0;
    public static final int MPI2COMM_mpiJavaS1	 	= 1;
    public static final int MPI2COMM_mpiJavaEncoder 	= 2;
}
