// -*- mode: Java; file-coding-system: *euc-japan*; -*-
// $Id: Encoder.java,v 1.2 1999/09/22 07:27:08 maeda Exp $
// Copyright (C) 1999 MAEDA Atusi

package jp.ac.tohoku.is.archi.mpi2.util;

/**
 * {@link EncodedData}{@link Encodable}񤭹िΥϥɥ.
 * 񤭹ߤϰʲμǹԤʤ
 * <ol>
 * <li> {@link EncodedData#getEncoder()}Encoder롥
 * <li> {@link #prepare(Encodable)}ǽ񤭹ͽΥǡΤ롥
 * <li> {@link #finishPrepare()}prepareեλХåեդ롥
 * <li> {@link #encode(Encodable)}ǥǡХåե˽񤭹ࡥ
 * <li> {@link #finishEncode()}ǽ񤭹ߤλ롥
 * </ol>
 * μλǡEncodedDataɤ֤ˤʤ롥
 * μϡ1ĤEncodedDataФƲٷ֤Ƥɤ
 */

public interface Encoder {

  /**
   * EncodedData˽񤭹ͽΥǡΤ.
   * @param data 񤭹ͽΥǡ
   */
  public void prepare(Encodable data);

  /**
   * ǡΤλХåեդ.
   * Υ᥽åɤƤӽФȡ{@link #encode}ƤӽФ֤ˤʤ롥
   * @see #prepare
   * @see encode
   */
  public void finishPrepare();

  /**
   * ꤷ礭ѥХåեդ.
   * Ʊ礭Υ֥ȤѤ롥
   * {@link Encodable}ǻꤷsizeĤ֤󷫤֤礭
   * Хåեդ롥
   *
   * @param decoder 1ĤǤ礭ꤹEncodable
   * @param size ǿ
   * @see #finishPrepare
   */
  public void allocate(Encodable data, int size);
  /**
   * Хåե˥ǡ1Ľ񤭹.
   * {@link #finishPrepare()}ɤ˸ƤӽФͤФʤʤ.
   */
  public void encode(Encodable data);

  /**
   * 񤭹ߤλ.
   * Υ᥽åɤƤӽФȡ{@link EncodedData#getArray}
   * Ф֤ˤʤ.
   */
  public void finishEncode();
}
